Linux Audio

Check our new training course

Loading...
v3.5.6
  1#!/bin/sh
 
  2#
  3# link vmlinux
  4#
  5# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
  6# $(KBUILD_VMLINUX_MAIN). Most are built-in.o files from top-level directories
  7# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
  8# Ordering when linking is important, and $(KBUILD_VMLINUX_INIT) must be first.
  9#
 10# vmlinux
 11#   ^
 12#   |
 13#   +-< $(KBUILD_VMLINUX_INIT)
 14#   |   +--< init/version.o + more
 15#   |
 16#   +--< $(KBUILD_VMLINUX_MAIN)
 17#   |    +--< drivers/built-in.o mm/built-in.o + more
 18#   |
 19#   +-< ${kallsymso} (see description in KALLSYMS section)
 20#
 21# vmlinux version (uname -v) cannot be updated during normal
 22# descending-into-subdirs phase since we do not yet know if we need to
 23# update vmlinux.
 24# Therefore this step is delayed until just before final link of vmlinux.
 25#
 26# System.map is generated to document addresses of all kernel symbols
 27
 28# Error out on error
 29set -e
 30
 
 
 
 
 
 
 
 
 31# Nice output in kbuild format
 32# Will be supressed by "make -s"
 33info()
 34{
 35	if [ "${quiet}" != "silent_" ]; then
 36		printf "  %-7s %s\n" ${1} ${2}
 37	fi
 38}
 39
 40# Link of vmlinux.o used for section mismatch analysis
 41# ${1} output file
 42modpost_link()
 43{
 44	${LD} ${LDFLAGS} -r -o ${1} ${KBUILD_VMLINUX_INIT}                   \
 45		--start-group ${KBUILD_VMLINUX_MAIN} --end-group
 46}
 47
 48# Link of vmlinux
 49# ${1} - optional extra .o files
 50# ${2} - output file
 51vmlinux_link()
 52{
 53	local lds="${objtree}/${KBUILD_LDS}"
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 54
 55	if [ "${SRCARCH}" != "um" ]; then
 56		${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2}                  \
 57			-T ${lds} ${KBUILD_VMLINUX_INIT}                     \
 58			--start-group ${KBUILD_VMLINUX_MAIN} --end-group ${1}
 
 59	else
 60		${CC} ${CFLAGS_vmlinux} -o ${2}                              \
 61			-Wl,-T,${lds} ${KBUILD_VMLINUX_INIT}                 \
 62			-Wl,--start-group                                    \
 63				 ${KBUILD_VMLINUX_MAIN}                      \
 64			-Wl,--end-group                                      \
 65			-lutil ${1}
 66		rm -f linux
 67	fi
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 68}
 69
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 70
 71# Create ${2} .o file with all symbols from the ${1} object file
 
 
 
 
 
 
 
 
 
 
 
 
 72kallsyms()
 73{
 74	info KSYM ${2}
 75	local kallsymopt;
 76
 77	if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
 78		kallsymopt=--all-symbols
 
 
 
 
 
 
 
 
 79	fi
 80
 81	local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL}               \
 82		      ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
 
 
 
 
 
 83
 84	${NM} -n ${1} | \
 85		scripts/kallsyms ${kallsymopt} | \
 86		${CC} ${aflags} -c -o ${2} -x assembler-with-cpp -
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 87}
 88
 89# Create map file with all symbols from ${1}
 90# See mksymap for additional details
 91mksysmap()
 92{
 
 93	${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
 94}
 95
 96sortextable()
 97{
 98	${objtree}/scripts/sortextable ${1}
 99}
100
101# Delete output files in case of error
102trap cleanup SIGHUP SIGINT SIGQUIT SIGTERM ERR
103cleanup()
104{
105	rm -f .old_version
106	rm -f .tmp_System.map
107	rm -f .tmp_kallsyms*
108	rm -f .tmp_version
109	rm -f .tmp_vmlinux*
110	rm -f System.map
111	rm -f vmlinux
112	rm -f vmlinux.o
113}
114
115#
116#
117# Use "make V=1" to debug this script
118case "${KBUILD_VERBOSE}" in
119*1*)
120	set -x
121	;;
122esac
123
124if [ "$1" = "clean" ]; then
125	cleanup
126	exit 0
127fi
128
129# We need access to CONFIG_ symbols
130. ./.config
131
132#link vmlinux.o
133info LD vmlinux.o
134modpost_link vmlinux.o
135
136# modpost vmlinux.o to check for section mismatches
137${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
138
139# Update version
140info GEN .version
141if [ ! -r .version ]; then
142	rm -f .version;
143	echo 1 >.version;
144else
145	mv .version .old_version;
146	expr 0$(cat .old_version) + 1 >.version;
147fi;
148
149# final build of init/
150${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
151
152kallsymso=""
 
153kallsyms_vmlinux=""
154if [ -n "${CONFIG_KALLSYMS}" ]; then
155
156	# kallsyms support
157	# Generate section listing all symbols and add it into vmlinux
158	# It's a three step process:
159	# 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
160	#     but __kallsyms is empty.
161	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
162	#     the right size
163	# 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
164	#     the right size, but due to the added section, some
165	#     addresses have shifted.
166	#     From here, we generate a correct .tmp_kallsyms2.o
167	# 2a) We may use an extra pass as this has been necessary to
168	#     woraround some alignment related bugs.
169	#     KALLSYMS_EXTRA_PASS=1 is used to trigger this.
170	# 3)  The correct ${kallsymso} is linked into the final vmlinux.
 
 
 
 
171	#
172	# a)  Verify that the System.map from vmlinux matches the map from
173	#     ${kallsymso}.
174
175	kallsymso=.tmp_kallsyms2.o
176	kallsyms_vmlinux=.tmp_vmlinux2
177
178	# step 1
179	vmlinux_link "" .tmp_vmlinux1
180	kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
181
182	# step 2
183	vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
184	kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
185
186	# step 2a
187	if [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
188		kallsymso=.tmp_kallsyms3.o
189		kallsyms_vmlinux=.tmp_vmlinux3
190
191		vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
192
193		kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
194	fi
195fi
196
197info LD vmlinux
198vmlinux_link "${kallsymso}" vmlinux
199
200if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
201	info SORTEX vmlinux
202	sortextable vmlinux
 
203fi
204
205info SYSMAP System.map
206mksysmap vmlinux System.map
207
208# step a (see comment above)
209if [ -n "${CONFIG_KALLSYMS}" ]; then
210	mksysmap ${kallsyms_vmlinux} .tmp_System.map
 
 
 
 
211
212	if ! cmp -s System.map .tmp_System.map; then
213		echo Inconsistent kallsyms data
214		echo echo Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
215		cleanup
 
216		exit 1
217	fi
218fi
219
220# We made a new kernel - delete old version file
221rm -f .old_version
v6.2
  1#!/bin/sh
  2# SPDX-License-Identifier: GPL-2.0
  3#
  4# link vmlinux
  5#
  6# vmlinux is linked from the objects in vmlinux.a and $(KBUILD_VMLINUX_LIBS).
  7# vmlinux.a contains objects that are linked unconditionally.
  8# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
  9# (not within --whole-archive), and do not require symbol indexes added.
 10#
 11# vmlinux
 12#   ^
 13#   |
 14#   +--< vmlinux.a
 
 15#   |
 16#   +--< $(KBUILD_VMLINUX_LIBS)
 17#   |    +--< lib/lib.a + more
 18#   |
 19#   +-< ${kallsymso} (see description in KALLSYMS section)
 20#
 21# vmlinux version (uname -v) cannot be updated during normal
 22# descending-into-subdirs phase since we do not yet know if we need to
 23# update vmlinux.
 24# Therefore this step is delayed until just before final link of vmlinux.
 25#
 26# System.map is generated to document addresses of all kernel symbols
 27
 28# Error out on error
 29set -e
 30
 31LD="$1"
 32KBUILD_LDFLAGS="$2"
 33LDFLAGS_vmlinux="$3"
 34
 35is_enabled() {
 36	grep -q "^$1=y" include/config/auto.conf
 37}
 38
 39# Nice output in kbuild format
 40# Will be supressed by "make -s"
 41info()
 42{
 43	printf "  %-7s %s\n" "${1}" "${2}"
 
 
 
 
 
 
 
 
 
 
 44}
 45
 46# Link of vmlinux
 47# ${1} - output file
 48# ${2}, ${3}, ... - optional extra .o files
 49vmlinux_link()
 50{
 51	local output=${1}
 52	local objs
 53	local libs
 54	local ld
 55	local ldflags
 56	local ldlibs
 57
 58	info LD ${output}
 59
 60	# skip output file argument
 61	shift
 62
 63	if is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT; then
 64		# Use vmlinux.o instead of performing the slow LTO link again.
 65		objs=vmlinux.o
 66		libs=
 67	else
 68		objs=vmlinux.a
 69		libs="${KBUILD_VMLINUX_LIBS}"
 70	fi
 71
 72	if is_enabled CONFIG_MODULES; then
 73		objs="${objs} .vmlinux.export.o"
 74	fi
 75
 76	objs="${objs} init/version-timestamp.o"
 77
 78	if [ "${SRCARCH}" = "um" ]; then
 79		wl=-Wl,
 80		ld="${CC}"
 81		ldflags="${CFLAGS_vmlinux}"
 82		ldlibs="-lutil -lrt -lpthread"
 83	else
 84		wl=
 85		ld="${LD}"
 86		ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
 87		ldlibs=
 
 
 
 88	fi
 89
 90	ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
 91
 92	# The kallsyms linking does not need debug symbols included.
 93	if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
 94		ldflags="${ldflags} ${wl}--strip-debug"
 95	fi
 96
 97	if is_enabled CONFIG_VMLINUX_MAP; then
 98		ldflags="${ldflags} ${wl}-Map=${output}.map"
 99	fi
100
101	${ld} ${ldflags} -o ${output}					\
102		${wl}--whole-archive ${objs} ${wl}--no-whole-archive	\
103		${wl}--start-group ${libs} ${wl}--end-group		\
104		$@ ${ldlibs}
105}
106
107# generate .BTF typeinfo from DWARF debuginfo
108# ${1} - vmlinux image
109# ${2} - file to dump raw BTF data into
110gen_btf()
111{
112	local pahole_ver
113
114	if ! [ -x "$(command -v ${PAHOLE})" ]; then
115		echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
116		return 1
117	fi
118
119	pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
120	if [ "${pahole_ver}" -lt "116" ]; then
121		echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
122		return 1
123	fi
124
125	vmlinux_link ${1}
126
127	info "BTF" ${2}
128	LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
129
130	# Create ${2} which contains just .BTF section but no symbols. Add
131	# SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
132	# deletes all symbols including __start_BTF and __stop_BTF, which will
133	# be redefined in the linker script. Add 2>/dev/null to suppress GNU
134	# objcopy warnings: "empty loadable segment detected at ..."
135	${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
136		--strip-all ${1} ${2} 2>/dev/null
137	# Change e_type to ET_REL so that it can be used to link final vmlinux.
138	# Unlike GNU ld, lld does not allow an ET_EXEC input.
139	printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
140}
141
142# Create ${2} .S file with all symbols from the ${1} object file
143kallsyms()
144{
 
145	local kallsymopt;
146
147	if is_enabled CONFIG_KALLSYMS_ALL; then
148		kallsymopt="${kallsymopt} --all-symbols"
149	fi
150
151	if is_enabled CONFIG_KALLSYMS_ABSOLUTE_PERCPU; then
152		kallsymopt="${kallsymopt} --absolute-percpu"
153	fi
154
155	if is_enabled CONFIG_KALLSYMS_BASE_RELATIVE; then
156		kallsymopt="${kallsymopt} --base-relative"
157	fi
158
159	if is_enabled CONFIG_LTO_CLANG; then
160		kallsymopt="${kallsymopt} --lto-clang"
161	fi
162
163	info KSYMS ${2}
164	scripts/kallsyms ${kallsymopt} ${1} > ${2}
165}
166
167# Perform one step in kallsyms generation, including temporary linking of
168# vmlinux.
169kallsyms_step()
170{
171	kallsymso_prev=${kallsymso}
172	kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
173	kallsymso=${kallsyms_vmlinux}.o
174	kallsyms_S=${kallsyms_vmlinux}.S
175
176	vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
177	mksysmap ${kallsyms_vmlinux} ${kallsyms_vmlinux}.syms
178	kallsyms ${kallsyms_vmlinux}.syms ${kallsyms_S}
179
180	info AS ${kallsyms_S}
181	${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
182	      ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
183	      -c -o ${kallsymso} ${kallsyms_S}
184}
185
186# Create map file with all symbols from ${1}
187# See mksymap for additional details
188mksysmap()
189{
190	info NM ${2}
191	${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
192}
193
194sorttable()
195{
196	${objtree}/scripts/sorttable ${1}
197}
198
199# Delete output files in case of error
 
200cleanup()
201{
202	rm -f .btf.*
 
 
 
 
203	rm -f System.map
204	rm -f vmlinux
205	rm -f vmlinux.map
206}
207
 
 
208# Use "make V=1" to debug this script
209case "${KBUILD_VERBOSE}" in
210*1*)
211	set -x
212	;;
213esac
214
215if [ "$1" = "clean" ]; then
216	cleanup
217	exit 0
218fi
219
220${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init init/version-timestamp.o
 
221
222btf_vmlinux_bin_o=""
223if is_enabled CONFIG_DEBUG_INFO_BTF; then
224	btf_vmlinux_bin_o=.btf.vmlinux.bin.o
225	if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
226		echo >&2 "Failed to generate BTF for vmlinux"
227		echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
228		exit 1
229	fi
230fi
 
 
 
 
 
 
 
 
 
 
231
232kallsymso=""
233kallsymso_prev=""
234kallsyms_vmlinux=""
235if is_enabled CONFIG_KALLSYMS; then
236
237	# kallsyms support
238	# Generate section listing all symbols and add it into vmlinux
239	# It's a three step process:
240	# 1)  Link .tmp_vmlinux.kallsyms1 so it has all symbols and sections,
241	#     but __kallsyms is empty.
242	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
243	#     the right size
244	# 2)  Link .tmp_vmlinux.kallsyms2 so it now has a __kallsyms section of
245	#     the right size, but due to the added section, some
246	#     addresses have shifted.
247	#     From here, we generate a correct .tmp_vmlinux.kallsyms2.o
248	# 3)  That link may have expanded the kernel image enough that
249	#     more linker branch stubs / trampolines had to be added, which
250	#     introduces new names, which further expands kallsyms. Do another
251	#     pass if that is the case. In theory it's possible this results
252	#     in even more stubs, but unlikely.
253	#     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
254	#     other bugs.
255	# 4)  The correct ${kallsymso} is linked into the final vmlinux.
256	#
257	# a)  Verify that the System.map from vmlinux matches the map from
258	#     ${kallsymso}.
259
260	kallsyms_step 1
261	kallsyms_step 2
 
 
 
 
 
 
 
 
262
263	# step 3
264	size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
265	size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
 
266
267	if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
268		kallsyms_step 3
 
269	fi
270fi
271
272vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
 
273
274# fill in BTF IDs
275if is_enabled CONFIG_DEBUG_INFO_BTF && is_enabled CONFIG_BPF; then
276	info BTFIDS vmlinux
277	${RESOLVE_BTFIDS} vmlinux
278fi
279
 
280mksysmap vmlinux System.map
281
282if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
283	info SORTTAB vmlinux
284	if ! sorttable vmlinux; then
285		echo >&2 Failed to sort kernel tables
286		exit 1
287	fi
288fi
289
290# step a (see comment above)
291if is_enabled CONFIG_KALLSYMS; then
292	if ! cmp -s System.map ${kallsyms_vmlinux}.syms; then
293		echo >&2 Inconsistent kallsyms data
294		echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
295		exit 1
296	fi
297fi
298
299# For fixdep
300echo "vmlinux: $0" > .vmlinux.d